MQSeries programming with ActiveX

Rommel K Abdon
Senior Systems Engineer
Client Server Technologies Inc (The Philippines)	c Xephon 2000



<%@ Language="VBScript"%>
<HTML>
<BODY>
<%
Set mqsess = Server.CreateObject ("MQAX200.MQSession")
'Set a high exception so we could handle errors
mqsess.ExceptionThreshold  = 3
'Connect to default queue manager
Set QMgr = mqsess.AccessQueueManager("")
   If mqsess.CompletionCode <> 0 Then
      Response.Write "Unable to connect to Queue Manager. " 
   Else
      Response.Write "Connected to Queue Manager"
   End If
%>
</BODY>
</HTML>


Dim QMgr as MQQueueManager         ' queue manager object

Set QMgr = New MQQueueManager    'Create an instance of a queue manager
QMgr.Connect                     'Connect to the default queue manager
MsgBox Str$(QMgr.CompletionCode) & " " & QMgr.ReasonName, vbOKOnly, _
       "Connect Result"


olenvQMgr = Create OLEObject
ll_result = olenvQMgr.ConnectToNewObject("MQAX200.MQQueueManager")

olenvQueue=olenvQMgr.AccessQueue("ProdLocQ",MQOO_OUTPUT+ &
MQOO_INPUT_AS_Q_DEF,"ProdQueueMgr")

MessageBox ("Open results", "Completion Code: " + string (olenvQueue.CompletionCode) + ", &
Reason Code: " + string (olenvQueue.ReasonCode))


Set msgPut = New MQMessage
msgPutStr = "This is a sample message" 
msgPut.MessageData = msgPutStr


<%@Language="VBScript"%>
<HTML>
<BODY>
<%
Set QMgr = Server.CreateObject("MQAX200.MQQueueManager")
Set Queue = QMgr.AccessQueue("ProdLocQ", MQOO_OUTPUT, "ProdQueueMgr")
Set msgPut = Server.CreateObject("MQAX200.MQMessage")
msgPutStr = "This is a sample text sent at:" & Time
msgPut.MessageData = msgPutStr
Queue.Put msgPut
%>
</BODY>
</HTML>


<%@ Language="Javascript"%>
<HTML>
<BODY>
<%
QMgr = Server.CreateObject("MQAX200.MQQueueManager")
Queue = QMgr.AccessQueue("ProdLocQ", MQOO_INPUT_AS_Q_DEF, "ProdQueueMgr")
msgGet = Server.CreateObject("MQAX200.MQMessage")
msgGet.MessageId = msgPut.MessageId
Queue.Get msgGet
msgGetStr = msgGet.ReadString(msgGet.MessageLength)
%>
</BODY>
</HTML>


Dim Queue As New MQQueue
Dim msgGet As New MQMessage
Dim msgGetOpt As New MQGetMessageOptions

'code for opening the queue is omitted

msgGetOpt.Options = MQGMO_WAIT
msgGetOpt.WaitInterval = 1000

Queue.Get msgGet, msgGetOpt


Qmgr.Begin
Queue.Get msgGet, msgGetOpt
'Database Transaction
EXEC SQL UPDATE TABLE EMPLOYEE SET EMP_NO= :hEmpNo 
'Check for errors, if none commit transaction
Qmgr.Commit


<HTML>
  <BODY>
    <!--'====================
        'create the HTML form
        '====================-->
    <FORM ACTION="mqput.asp" METHOD="POST">
      Queue Name: <INPUT TYPE="TEXT" NAME="QueueNm"></INPUT><BR>
      Message: <INPUT TYPE="TEXT" NAME="PutMsg"></INPUT>
      <INPUT TYPE="SUBMIT" VALUE="Put Message"></INPUT>
      <INPUT TYPE="RESET" VALUE="Reset"></INPUT>
    </FORM>
  </BODY>
</HTML>


<%@ Language="VBScript"%>
<HTML>
<TITLE>Simple Put Message</TITLE>
<BODY>
<%
'===========================
'retrieve values from the HTML Form
'===========================
QueueNm = Request.Form("QueueNm")
PutMsg = Request.Form("PutMsg")

'=====================
'create an MQSession object
'=====================

Set mqsess = Server.CreateObject ("MQAX200.MQSession")
On Error Resume Next
'=================================
'Set a high exception so we can handle errors
'=================================

mqsess.ExceptionThreshold  = 3

'=========================
'Connect to default queue manager
'=========================
Set QMgr = mqsess.AccessQueueManager("")

'============================================
' check for failures, then write appropriate message to the page
'============================================

   If mqsess.CompletionCode <> 0 Then
          Response.Write "Unable to connect to Queue Manager. "
   End If

'====================================
' declare constant, you can put this in an include file
'====================================
MQOO_OUTPUT = 16
MQOO_INPUT_AS_Q_DEF = 1
MQPMO_FAIL_IF_QUIESCING = 8192

'==========================
' access the queue that was specified
'==========================
Set Queue = QMgr.AccessQueue(cstr(QueueNm), MQOO_OUTPUT + MQOO_INPUT_AS_Q_DEF)
If mqsess.CompletionCode <> 0 Then
          Response.Write "Unable To Open Queue." 
End If

'======================================================
' create a new message and put option object using the MQSession method
'=====================================================
Set MsgPut = mqsess.AccessMessage()
Set msgPutOpt = mqsess.AccessPutMessageOptions()
msgPutOpt.Options = MQPMO_FAIL_IF_QUIESCING

'=============================
' write the message , then put to the queue
'=============================

MsgPut.WriteString cstr(PutMsg)
Queue.Put MsgPut, msgPutOpt

If mqsess.CompletionCode = 0 then
    Response.Write "The message has been successfully sent!"
End If

%>
</BODY>
</HTML>


